Index: TWiki/Form.pm
===================================================================
--- TWiki/Form.pm	(revision 13172)
+++ TWiki/Form.pm	(working copy)
@@ -62,7 +62,7 @@
 
 =pod
 
----++ ClassMethod new ( $session, $web, $form, $def )
+---++ ClassMethod new ( $web, $form, $def )
 
    * $web - default web to recover form from, if $form doesn't specify a web
    * =$form= - topic name to read form definition from
@@ -74,26 +74,23 @@
 =cut
 
 sub new {
-    my( $class, $session, $web, $form, $def ) = @_;
+    my( $class, $web, $form, $def ) = @_;
     my $this = bless( {}, $class );
 
     ( $web, $form ) =
-      $session->normalizeWebTopicName( $web, $form );
+      $TWiki::SESSION->normalizeWebTopicName( $web, $form );
 
-    my $store = $session->{store};
-
-    $this->{session} = $session;
     $this->{web} = $web;
     $this->{topic} = $form;
 
     unless ( $def ) {
 
         # Read topic that defines the form
-        unless( $store->topicExists( $web, $form ) ) {
+        unless( $TWiki::STORE->topicExists( $web, $form ) ) {
             return undef;
         }
         my( $meta, $text ) =
-          $store->readTopic( $session->{user}, $web, $form, undef );
+          $TWiki::STORE->readTopic( $TWiki::SESSION->{user}, $web, $form, undef );
 
         $this->{fields} = $this->_parseFormDefinition( $meta, $text );
 
@@ -112,14 +109,14 @@
             @posValues = split( /,/, $fieldDef->{value} );
             my $topic = $fieldDef->{definingTopic} || $fieldDef->{name};
             my( $fieldWeb, $fieldTopic ) =
-              $session->normalizeWebTopicName($web, $topic);
+              $TWiki::SESSION->normalizeWebTopicName($web, $topic);
             if (!scalar(@posValues)) {
-                if ( $store->topicExists( $fieldWeb, $fieldTopic ) ) {
+                if ( $TWiki::STORE->topicExists( $fieldWeb, $fieldTopic ) ) {
                     my( $meta, $text ) =
-                      $store->readTopic( $session->{user},
+                      $TWiki::STORE->readTopic( $TWiki::SESSION->{user},
                                          $fieldWeb, $fieldTopic, undef );
                     # Add processing of SEARCHES for Lists
-                    $text = $this->{session}->handleCommonTags(
+                    $text = $TWiki::SESSION->handleCommonTags(
                         $text, $this->{web}, $this->{topic}, $meta);
                     @posValues = _getPossibleFieldValues( $text );
                     $fieldDef->{type} ||= 'select';  #FIXME keep?
@@ -146,7 +143,6 @@
 sub _parseFormDefinition {
     my( $this, $meta, $text ) = @_;
 
-    my $store = $this->{session}->{store};
     my @fields = ();
     my $inBlock = 0;
     $text =~ s/\\\r?\n//go; # remove trailing '\' and join continuation lines
@@ -188,7 +184,7 @@
             }
 
             $vals ||= '';
-            $vals = $this->{session}->handleCommonTags(
+            $vals = $TWiki::SESSION->handleCommonTags(
                 $vals, $this->{web}, $this->{topic}, $meta);
             $vals =~ s/<\/?(nop|noautolink)\/?>//go;
             $vals =~ s/^\s*//go;
@@ -198,7 +194,7 @@
             if( $vals eq '$users' ) {
                 $vals = $TWiki::cfg{UsersWebName} . '.' .
                   join( ", ${TWiki::cfg{UsersWebName}}.",
-                        ( $store->getTopicNames( $TWiki::cfg{UsersWebName} ) ) );
+                        ( $TWiki::STORE->getTopicNames( $TWiki::cfg{UsersWebName} ) ) );
             }
 
             $tooltip ||= '';
@@ -237,12 +233,6 @@
     return \@fields;
 }
 
-sub _searchVals {
-    my ( $session, $arg ) = @_;
-    $arg =~ s/%WEB%/$session->{webName}/go;
-    return $session->_SEARCH(new TWiki::Attrs($arg), $session->{topicName}, $session->{webName});
-}
-
 # Chop out all except A-Za-z0-9_.
 # I'm sure there must have been a good reason for this once.
 sub _cleanField {
@@ -292,27 +282,26 @@
     $string =~ s/[\[\]]//go;
 
     $topic ||= $string;
-    $tooltip ||= $this->{session}->{i18n}->maketext('Click to see details in separate window');
+    $tooltip ||= $TWiki::I18N->maketext('Click to see details in separate window');
 
     my $web;
     ( $web, $topic ) =
-      $this->{session}->normalizeWebTopicName( $this->{web}, $topic );
+      $TWiki::SESSION->normalizeWebTopicName( $this->{web}, $topic );
 
     my $link;
 
-    my $store = $this->{session}->{store};
-    if( $store->topicExists( $web, $topic ) ) {
+    if( $TWiki::STORE->topicExists( $web, $topic ) ) {
         $link =
           CGI::a(
               { target => $topic,
                 onclick => 'return launchWindow("'.$web.'","'.$topic.'")',
                 title => $tooltip,
-                href =>$this->{session}->getScriptUrl( 0, 'view',
+                href =>$TWiki::SESSION->getScriptUrl( 0, 'view',
                                                        $web, $topic ),
                 rel => 'nofollow'
                }, $string );
     } else {
-        my $expanded = $this->{session}->handleCommonTags(
+        my $expanded = $TWiki::SESSION->handleCommonTags(
             $string, $web, $topic, $meta );
         if ( $tooltip ) {
             $link = CGI::span ( { title => $tooltip }, $expanded );
@@ -341,14 +330,12 @@
     my( $this, $web, $topic, $meta ) = @_;
     ASSERT($this->isa( 'TWiki::Form')) if DEBUG;
     ASSERT($meta->isa( 'TWiki::Meta')) if DEBUG;
-    my $session = $this->{session};
 
-
     if( $this->{mandatoryFieldsPresent} ) {
-        $session->enterContext( 'mandatoryfields' );
+        $TWiki::SESSION->enterContext( 'mandatoryfields' );
     }
-    my $tmpl = $session->{templates}->readTemplate( "form" );
-    $tmpl = $session->handleCommonTags( $tmpl, $web, $topic, $meta );
+    my $tmpl = $TWiki::TEMPLATES->readTemplate( "form" );
+    $tmpl = $TWiki::SESSION->handleCommonTags( $tmpl, $web, $topic, $meta );
 
     # Note: if WEBFORMS preference is not set, can only delete form.
     $tmpl =~ s/%FORMTITLE%/$this->_link($meta, $this->{web}.'.'.$this->{topic})/geo;
@@ -364,8 +351,8 @@
             # Special handling for untitled labels
             my $tmp = $repeatUntitledText;
             my $value =
-              $session->{renderer}->getRenderedVersion(
-                  $session->handleCommonTags(
+              $TWiki::RENDER->getRenderedVersion(
+                  $TWiki::SESSION->handleCommonTags(
                       $fieldDef->{value}, $web, $topic, $meta ));
             $tmp =~ s/%ROWVALUE%/$value/go;
             $text .= $tmp;
@@ -383,7 +370,7 @@
                 # definition. Doesn't make sense for checkboxes.
                 $value = $fieldDef->{value};
                 if( defined( $value )) {
-                    $value = $session->handleCommonTags(
+                    $value = $TWiki::SESSION->handleCommonTags(
                         $value, $web, $topic, $meta );
                     $value = TWiki::expandStandardEscapes( $value ); # Item2837
                 }
@@ -429,7 +416,6 @@
     my $size = $fieldDef->{size};
     my $attributes = $fieldDef->{attributes} || '';
     my $extra = '';
-    my $session = $this->{session};
 
     if( $attributes =~ /M/ ) {
         $extra = CGI::span( { class => 'twikiAlert' }, ' *' );
@@ -443,7 +429,7 @@
     $name = $this->cgiName( $name );
 
     # Give plugin field types a chance first
-    my $output = $session->{plugins}->renderFormFieldForEditHandler
+    my $output = $TWiki::PLUGINS->renderFormFieldForEditHandler
       ( $name, $type, $size, $value, $attributes, $fieldDef->{value} );
 
     if( $output ) {
@@ -470,8 +456,8 @@
 				     -alt => 'Calendar',
 				     -class => 'twikiButton twikiEditFormCalendarButton' );
 	$value .= '%ENDTWISTY%';
-	$value = $session->{renderer}->getRenderedVersion(
-        $session->handleCommonTags( $value, $web, $topic ));
+	$value = $TWiki::RENDER->getRenderedVersion(
+        $TWiki::SESSION->handleCommonTags( $value, $web, $topic ));
       }
     } elsif( $type eq 'text' ) {
         $value = CGI::textfield( -class => 'twikiInputField twikiEditFormTextField',
@@ -486,8 +472,8 @@
         # take it from the text, we must be sure it cannot be
         # changed through the URL?
         # Pth: Changed labels through the URL is a feature for TWiki applications
-        my $renderedValue = $session->{renderer}->getRenderedVersion
-          ( $session->handleCommonTags( $value, $web, $topic ));
+        my $renderedValue = $TWiki::RENDER->getRenderedVersion
+          ( $TWiki::SESSION->handleCommonTags( $value, $web, $topic ));
         $value = CGI::hidden( -name => $name,
                               -value => $value );
         $value .= CGI::div( { class => 'twikiEditFormLabelField' },
@@ -576,12 +562,12 @@
             $extra = CGI::br();
             $extra .= CGI::button
               ( -class => 'twikiCheckBox twikiEditFormCheckboxButton',
-                -value => $session->{i18n}->maketext('Set all'),
+                -value => $TWiki::I18N->maketext('Set all'),
                 -onClick => 'checkAll(this,2,'.$boxes.',true)' );
             $extra .= '&nbsp;';
             $extra .= CGI::button
               ( -class => 'twikiCheckBox twikiEditFormCheckboxButton',
-                -value => $session->{i18n}->maketext('Clear all'),
+                -value => $TWiki::I18N->maketext('Clear all'),
                 -onClick => 'checkAll(this,1,'.$boxes.',false)');
         }
         my %isSelected = map { $_ => 1 } split(/\s*,\s*/, $value);
@@ -589,7 +575,7 @@
             #NOTE: Does not expand $item in label
             $attrs{$item} =
               { class => 'twikiEditFormCheckboxField',
-                label => $session->handleCommonTags(
+                label => $TWiki::SESSION->handleCommonTags(
                     $item, $web, $topic )
                };
 
@@ -617,7 +603,7 @@
         foreach $item ( @$options ) {
             $attrs{$item} =
               { class=>'twikiRadioButton twikiEditFormRadioField',
-                label=>$session->handleCommonTags(
+                label=>$TWiki::SESSION->handleCommonTags(
                     $item, $web, $topic ) };
 
             $selected = $item if( $item eq $value );
@@ -655,7 +641,6 @@
     my( $this, $meta ) = @_;
     ASSERT($this->isa( 'TWiki::Form')) if DEBUG;
     ASSERT($meta->isa( 'TWiki::Meta')) if DEBUG;
-    my $session = $this->{session};
 
     my $text = "";
 
@@ -737,8 +722,8 @@
 
         if (defined $value) {
             $seen++;
-            if ($this->{session}->inContext('edit')) {
-                $value  =  TWiki::expandStandardEscapes( $value );
+            if ($TWiki::SESSION->inContext('edit')) {
+                $value = TWiki::expandStandardEscapes( $value );
             }
         }
 
Index: TWiki/Client/TemplateLogin.pm
===================================================================
--- TWiki/Client/TemplateLogin.pm	(revision 13172)
+++ TWiki/Client/TemplateLogin.pm	(working copy)
@@ -36,20 +36,18 @@
 =cut
 
 package TWiki::Client::TemplateLogin;
+use base 'TWiki::Client';
 
 use strict;
 use Assert;
-use TWiki::Client;
 
-@TWiki::Client::TemplateLogin::ISA = ( 'TWiki::Client' );
-
 sub new {
-    my( $class, $session ) = @_;
+    my( $class ) = @_;
 
-    my $this = bless( $class->SUPER::new($session), $class );
-    $session->enterContext( 'can_login' );
+    my $this = bless( $class->SUPER::new(), $class );
+    $TWiki::SESSION->enterContext( 'can_login' );
     if ($TWiki::cfg{Sessions}{ExpireCookiesAfter}) {
-        $session->enterContext( 'can_remember_login' );
+        $TWiki::SESSION->enterContext( 'can_remember_login' );
     }
     return $this;
 }
@@ -57,17 +55,15 @@
 # Triggered on auth fail
 sub forceAuthentication {
     my $this = shift;
-    my $twiki = $this->{twiki};
 
-    unless( $twiki->inContext( 'authenticated' )) {
-        my $query = $twiki->{cgiQuery};
+    unless( $TWiki::SESSION->inContext( 'authenticated' )) {
+        my $query = $TWiki::SESSION->{cgiQuery};
         # Redirect with passthrough so we don't lose the original query params
-        my $twiki = $this->{twiki};
-        my $topic = $twiki->{topicName};
-        my $web = $twiki->{webName};
-        my $url = $twiki->getScriptUrl( 0, 'login', $web, $topic);
+        my $topic = $TWiki::SESSION->{topicName};
+        my $web = $TWiki::SESSION->{webName};
+        my $url = $TWiki::SESSION->getScriptUrl( 0, 'login', $web, $topic);
         $query->param( -name=>'origurl', -value=>$ENV{REQUEST_URI} );
-        $twiki->redirect( $url, 1 );
+        $TWiki::SESSION->redirect( $url, 1 );
         return 1;
     }
     return undef;
@@ -76,11 +72,10 @@
 # Content of a login link
 sub loginUrl {
     my $this = shift;
-    my $twiki = $this->{twiki};
-    my $topic = $twiki->{topicName};
-    my $web = $twiki->{webName};
-    my $query = $twiki->{cgiQuery};
-    return $twiki->getScriptUrl( 0, 'login', $web, $topic,
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
+    my $query = $TWiki::SESSION->{cgiQuery};
+    return $TWiki::SESSION->getScriptUrl( 0, 'login', $web, $topic,
                                  origurl => $ENV{REQUEST_URI} );
 }
 
@@ -107,8 +102,7 @@
 =cut
 
 sub login {
-    my( $this, $query, $twikiSession ) = @_;
-    my $twiki = $this->{twiki};
+    my( $this, $query ) = @_;
 
     my $origurl = $query->param( 'origurl' );
     my $loginName = $query->param( 'username' );
@@ -118,38 +112,39 @@
     # Eat these so there's no risk of accidental passthrough
     $query->delete('origurl', 'username', 'password');
 
-    my $tmpl = $twiki->{templates}->readTemplate(
-        'login', $twiki->getSkin() );
+    my $tmpl = $TWiki::TEMPLATES->readTemplate(
+        'login', $TWiki::SESSION->getSkin() );
 
-    my $banner = $twiki->{templates}->expandTemplate( 'LOG_IN_BANNER' );
+    my $banner = $TWiki::TEMPLATES->expandTemplate( 'LOG_IN_BANNER' );
     my $note = '';
-    my $topic = $twiki->{topicName};
-    my $web = $twiki->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
 
     my $cgisession = $this->{_cgisession};
 
     $cgisession->param( 'REMEMBER', $remember ) if $cgisession;
     if( $cgisession && $cgisession->param( 'AUTHUSER' ) &&
           $loginName ne $cgisession->param( 'AUTHUSER' )) {
-        $banner = $twiki->{templates}->expandTemplate( 'LOGGED_IN_BANNER' );
-        $note = $twiki->{templates}->expandTemplate( 'NEW_USER_NOTE' );
+        $banner = $TWiki::TEMPLATES->expandTemplate( 'LOGGED_IN_BANNER' );
+        $note = $TWiki::TEMPLATES->expandTemplate( 'NEW_USER_NOTE' );
     }
 
     if( $loginName ) {
-        my $passwordHandler = $twiki->{users}->{passwords};
+        my $passwordHandler = $TWiki::USERS->{passwords};
         my $validation = $passwordHandler->checkPassword( $loginName, $loginPass );
 
         if( $validation ) {
             $this->userLoggedIn( $loginName );
             $cgisession->param( 'VALIDATION', $validation ) if $cgisession;
             if( !$origurl || $origurl eq $query->url() ) {
-                $origurl = $twiki->getScriptUrl( 0, 'view', $web, $topic );
+                $origurl = $TWiki::SESSION->getScriptUrl(
+                    0, 'view', $web, $topic );
             }
             # Redirect with passthrough
-            $twikiSession->redirect($origurl, 1 );
+            $TWiki::SESSION->redirect($origurl, 1 );
             return;
         } else {
-            $banner = $twiki->{templates}->expandTemplate('UNRECOGNISED_USER');
+            $banner = $TWiki::TEMPLATES->expandTemplate('UNRECOGNISED_USER');
         }
     }
 
@@ -160,10 +155,10 @@
     $tmpl =~ s/%BANNER%/$banner/g;
     $tmpl =~ s/%NOTE%/$note/g;
 
-    $tmpl = $twiki->handleCommonTags( $tmpl, $web, $topic );
-    $tmpl = $twiki->{renderer}->getRenderedVersion( $tmpl, '' );
+    $tmpl = $TWiki::SESSION->handleCommonTags( $tmpl, $web, $topic );
+    $tmpl = $TWiki::SESSION::RENDER->getRenderedVersion( $tmpl, '' );
     $tmpl =~ s/<nop>//g;
-    $twiki->writePageHeader( $query );
+    $TWiki::SESSION->writePageHeader( $query );
     print $tmpl;
 }
 
Index: TWiki/Client/ApacheLogin.pm
===================================================================
--- TWiki/Client/ApacheLogin.pm	(revision 13172)
+++ TWiki/Client/ApacheLogin.pm	(working copy)
@@ -41,16 +41,15 @@
 =cut
 
 package TWiki::Client::ApacheLogin;
+use base 'TWiki::Client';
 
 use strict;
 use Assert;
 
-@TWiki::Client::ApacheLogin::ISA = qw( TWiki::Client );
-
 sub new {
-    my( $class, $twiki ) = @_;
-    my $this = bless( $class->SUPER::new($twiki), $class );
-    $twiki->enterContext( 'can_login', 1 );
+    my( $class ) = @_;
+    my $this = bless( $class->SUPER::new(), $class );
+    $TWiki::SESSION->enterContext( 'can_login', 1 );
     # Can't logout, though
     TWiki::registerTagHandler('LOGOUT', sub { return '' });
     return $this;
@@ -59,8 +58,7 @@
 sub forceAuthentication {
     my $this = shift;
 
-    my $twiki = $this->{twiki};
-    my $query = $twiki->{cgiQuery};
+    my $query = $TWiki::SESSION->{cgiQuery};
 
     # See if there is an 'auth' version
     # of this script, may be a result of not being logged in.
@@ -79,22 +77,22 @@
         if( $url && $url =~ m!(.*/$scriptName)([^?]*)! ) {
             # $url should not contain query string as it gets appended
             # in TWiki::redirect. Script gets 'auth' appended.
-            $url = "$twiki->{urlHost}${1}auth$2";
+            $url = "$TWiki::SESSION->{urlHost}${1}auth$2";
         } else {
             if( $ENV{SCRIPT_NAME} &&
                    $ENV{SCRIPT_NAME} =~ s/\/$scriptName/\/${scriptName}auth/ ) {
-                $url = $twiki->{urlHost}.$ENV{SCRIPT_NAME};
+                $url = $TWiki::SESSION->{urlHost}.$ENV{SCRIPT_NAME};
             } else {
                 # If SCRIPT_NAME does not contain the script name
                 # the last hope is to try building up the URL using
                 # the SCRIPT_FILENAME.
-                $url = $twiki->{urlHost}.$twiki->{scriptUrlPath}.'/'.
+                $url = $TWiki::SESSION->{urlHost}.$TWiki::SESSION->{scriptUrlPath}.'/'.
                        $scriptName.'auth'.$TWiki::cfg{ScriptSuffix};
             }
             $url .= '/' . $ENV{PATH_INFO} if $ENV{PATH_INFO};
         }
         # Redirect with passthrough so we don't lose the original query params
-        $twiki->redirect( $url, 1 );
+        $TWiki::SESSION->redirect( $url, 1 );
         return 1;
     }
 
@@ -103,15 +101,14 @@
 
 sub loginUrl {
     my $this = shift;
-    my $twiki = $this->{twiki};
-    my $topic = $twiki->{topicName};
-    my $web = $twiki->{webName};
-    return $twiki->getScriptUrl( 0, 'logon', $web, $topic, @_ );
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
+    return $TWiki::SESSION->getScriptUrl( 0, 'logon', $web, $topic, @_ );
 }
 
 sub getUser {
     my $this = shift;
-    my $query = $this->{twiki}->{cgiQuery};
+    my $query = $TWiki::SESSION->{cgiQuery};
     my $authUser;
     # Ignore remote user if we got here via an error
     unless (($ENV{REDIRECT_STATUS} || 0) >= 400 ) {
Index: TWiki/I18N/Extract.pm
===================================================================
--- TWiki/I18N/Extract.pm	(revision 13172)
+++ TWiki/I18N/Extract.pm	(working copy)
@@ -42,25 +42,20 @@
 
 =pod
 
----++ ClassMethod new ( $session ) -> $extract
+---++ ClassMethod new() -> $extract
 
-Constructor. Creates a fresh new Extract object. A $session object, instance of
-the TWiki class, is optional: if it's available, it'll be used for printing
-warnings.
-
+Constructor. Creates a fresh new Extract object.
 =cut
 
 sub new {
     my $class = shift;
-    my $session = shift;
 
     unless ( $initialised ) {
-        $session->writeWarning ( $initError ) if $session;
+        $TWiki::SESSION->writeWarning ( $initError );
         return undef;
     }
 
     my $self = new Locale::Maketext::Extract;
-    $self->{session} = $session;
     return bless($self, $class);
 }
 
Index: TWiki/I18N.pm
===================================================================
--- TWiki/I18N.pm	(revision 13172)
+++ TWiki/I18N.pm	(working copy)
@@ -109,19 +109,16 @@
 
 =pod
 
----++ ClassMethod get ( $session )
+---++ ClassMethod get ()
 
 Constructor. Gets the language object corresponding to the current user's language.
 
 =cut
 
 sub get {
-    my $session  = shift;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
-
     unless ($initialised) {
         foreach my $error (@initErrors) {
-            $session->writeWarning($error);
+            $TWiki::SESSION->writeWarning($error);
         }
     }
 
@@ -131,8 +128,8 @@
     #   browser.
     my $this;
     if ($initialised) {
-        $session->enterContext( 'i18n_enabled' );
-        my $userLanguage = _normalize_language_tag($session->{prefs}->getPreferencesValue('LANGUAGE'));
+        $TWiki::SESSION->enterContext( 'i18n_enabled' );
+        my $userLanguage = _normalize_language_tag($TWiki::PREFS->getPreferencesValue('LANGUAGE'));
         if ($userLanguage) {
             $this = TWiki::I18N->get_handle($userLanguage);
         } else {
@@ -145,13 +142,10 @@
 
         # we couldn't initialise 'optional' I18N infrastructure, warn that we
         # can only use English if I18N has been requested with configure
-        $session->writeWarning('Could not load I18N infrastructure; falling back to English')
+        $TWiki::SESSION->writeWarning('Could not load I18N infrastructure; falling back to English')
           if $TWiki::cfg{UserInterfaceInternationalisation};
     }
 
-    # keep a reference to the session object
-    $this->{session} = $session;
-
     # languages we know about
     $this->{enabled_languages} = { en => 'English' };
     $this->{checked_enabled}   = undef;
@@ -204,7 +198,7 @@
     }
 
     my $result = $this->SUPER::maketext($text, @args);
-    if ($result && $this->{session}) {
+    if ($result) {
         # external calls get the resultant text in the right charset:
         $result = $this->toSiteCharSet($result);
     }
@@ -311,7 +305,7 @@
                                              -charset => $encoding
                                             });
         } else {
-          $this->{session}->writeWarning
+          $TWiki::SESSION->writeWarning
             ( 'Conversion from $encoding no supported, '.
               'or name not recognised - check perldoc Unicode::MapUTF8' );
           return $text;
@@ -322,7 +316,7 @@
         import Encode;
         my $encoding = Encode::resolve_alias ( $TWiki::cfg{Site}{CharSet} );
         if ( not $encoding ) {
-            $this->{session}->writeWarning
+            $TWiki::SESSION->writeWarning
               ( 'Conversion to "'.$TWiki::cfg{Site}{CharSet}.
                 '" not supported, or name not recognised - check '.
                 '"perldoc Encode::Supported"' );
@@ -367,7 +361,7 @@
                                              -charset => $encoding
                                             });
         } else {
-          $this->{session}->writeWarning
+          $TWiki::SESSION->writeWarning
             ( 'Conversion to $encoding no supported, '.
               'or name not recognised - check perldoc Unicode::MapUTF8' );
           return $encoded;
@@ -377,7 +371,7 @@
         import Encode;
         my $encoding = Encode::resolve_alias ( $TWiki::cfg{Site}{CharSet} );
         if ( not $encoding ) {
-            $this->{session}->writeWarning
+            $TWiki::SESSION->writeWarning
               ( 'Conversion from "'.$TWiki::cfg{Site}{CharSet}.
                 '" not supported, or name not recognised - check '.
                 '"perldoc Encode::Supported"' );
Index: TWiki/Users/HtPasswdUser.pm
===================================================================
--- TWiki/Users/HtPasswdUser.pm	(revision 13172)
+++ TWiki/Users/HtPasswdUser.pm	(working copy)
@@ -53,8 +53,8 @@
 }
 
 sub new {
-    my( $class, $session) = @_;
-    my $this = bless( $class->SUPER::new($session), $class );
+    my( $class ) = @_;
+    my $this = bless( $class->SUPER::new(), $class );
     $this->{error} = undef;
     if( $TWiki::cfg{Htpasswd}{Encoding} eq 'md5' ) {
         require Digest::MD5;
Index: TWiki/Users/ApacheHtpasswdUser.pm
===================================================================
--- TWiki/Users/ApacheHtpasswdUser.pm	(revision 13172)
+++ TWiki/Users/ApacheHtpasswdUser.pm	(working copy)
@@ -42,9 +42,9 @@
 =cut
 
 sub new {
-    my( $class, $session ) = @_;
+    my( $class ) = @_;
 
-    my $this = bless( $class->SUPER::new( $session ), $class );
+    my $this = bless( $class->SUPER::new( ), $class );
     $this->{apache} = new Apache::Htpasswd
       ( { passwdFile => $TWiki::cfg{Htpasswd}{FileName} } );
     $this->{error} = undef;
Index: TWiki/Users/Password.pm
===================================================================
--- TWiki/Users/Password.pm	(revision 13172)
+++ TWiki/Users/Password.pm	(working copy)
@@ -36,18 +36,16 @@
 
 =pod
 
----++ ClassMethod new( $session ) -> $object
+---++ ClassMethod new() -> $object
 
-Constructs a new password handler of this type, referring to $session
-for any required TWiki services.
+Constructs a new password handler of this type.
 
 =cut
 
 sub new {
-    my( $class, $session ) = @_;
+    my( $class ) = @_;
 
     my $this = bless( {}, $class );
-    $this->{session} = $session;
     return $this;
 }
 
@@ -180,11 +178,11 @@
 sub getEmails {
     my( $this, $login ) = @_;
 
-    my $user = $this->{session}->{users}->findUser( $login, undef, 1 );
+    my $user = $TWiki::USERS->findUser( $login, undef, 1 );
     return () unless $user;
 
     my ($meta, $text) =
-      $this->{session}->{store}->readTopic(
+      $TWiki::STORE->readTopic(
           undef, $TWiki::cfg{UsersWebName}, $user->wikiName() );
 
     my @addresses;
@@ -218,11 +216,11 @@
     my $login = shift;
     my $mails = join( ';', @_ );
 
-    my $user = $this->{session}->{users}->findUser( $login, undef, 1 );
+    my $user = $TWiki::USERS->findUser( $login, undef, 1 );
     return () unless $user;
 
     my ($meta, $text) =
-      $this->{session}->{store}->readTopic(
+      $TWiki::STORE->readTopic(
           undef, $TWiki::cfg{UsersWebName}, $user->wikiName() );
 
     if ($meta->get('FORM')) {
@@ -239,7 +237,7 @@
         }
     }
 
-    $this->{session}->{store}->saveTopic( $user, $TWiki::cfg{UsersWebName},
+    $TWiki::STORE->saveTopic( $user, $TWiki::cfg{UsersWebName},
                                   $user->wikiName(), $text, $meta );
 }
 
@@ -251,7 +249,7 @@
     # we have to cheat. We do this as follows:
     unless( $this->{_MAP_OF_EMAILS} ) {
         $this->{_MAP_OF_EMAILS} = ();
-        my $it = $this->{session}->{users}->eachUser();
+        my $it = $TWiki::USERS->eachUser();
         while( $it->hasNext() ) {
             my $uo = $it->next();
 ASSERT($uo->isa('TWiki::User'));
Index: TWiki/Users/TWikiUserMapping.pm
===================================================================
--- TWiki/Users/TWikiUserMapping.pm	(revision 13172)
+++ TWiki/Users/TWikiUserMapping.pm	(working copy)
@@ -51,18 +51,16 @@
 
 =pod
 
----++ ClassMethod new( $session ) -> $object
+---++ ClassMethod new( ) -> $object
 
-Constructs a new user mapping handler of this type, referring to $session
-for any required TWiki services.
+Constructs a new user mapping handler of this type
 
 =cut
 
 sub new {
-    my( $class, $session ) = @_;
+    my( $class ) = @_;
 
     my $this = bless( {}, $class );
-    $this->{session} = $session;
 
     %{$this->{U2W}} = ();
     %{$this->{W2U}} = ();
@@ -90,7 +88,7 @@
     my $ref = shift;
     my $group = shift;
     return unless $group;
-    my $groupObject = $ref->{users}->findUser( $group );
+    my $groupObject = $TWiki::USERS->findUser( $group );
     push (@{$ref->{list}}, $groupObject) if $groupObject;
 }
 
@@ -100,10 +98,10 @@
     ASSERT(ref($this) eq 'TWiki::Users::TWikiUserMapping') if DEBUG;
 
     unless( $this->{groupsList} ) {
-        my $users = $this->{session}->{users};
+        my $users = $TWiki::USERS;
         $this->{groupsList} = [];
 
-        $this->{session}->{search}->searchWeb
+        $TWiki::SEARCH->searchWeb
           (
               _callback     => \&_collateGroups,
               _cbdata       =>  { list => $this->{groupsList},
@@ -147,7 +145,7 @@
     ASSERT($user->isa( 'TWiki::User')) if DEBUG;
     ASSERT($me->isa( 'TWiki::User')) if DEBUG;
 
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
     my( $meta, $text ) =
       $store->readTopic( undef, $TWiki::cfg{UsersWebName},
                          $TWiki::cfg{UsersTopicName}, undef );
@@ -259,8 +257,8 @@
     ASSERT($this->isa( 'TWiki::Users::TWikiUserMapping')) if DEBUG;
 
     $this->_loadMapping();
-    my $users = $this->{session}->{users};
-    my @list = map { $users->findUser($_) } keys(%{$this->{W2U}});
+
+    my @list = map { $TWiki::USERS->findUser($_) } keys(%{$this->{W2U}});
     return new TWiki::ListIterator( \@list );
 }
 
@@ -287,7 +285,7 @@
     return if $this->{CACHED};
     $this->{CACHED} = 1;
 
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
     if( $store->topicExists($TWiki::cfg{UsersWebName},
                             $TWiki::cfg{UsersTopicName} )) {
         my $text = $store->readTopicRaw( undef,
@@ -337,7 +335,7 @@
     my $this = shift;
     my $group = shift;
     ASSERT($this->isa( 'TWiki::Users::TWikiUserMapping')) if DEBUG;
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
 
     if( !defined $group->{members} &&
           $store->topicExists( $group->{web}, $group->{wikiname} )) {
@@ -351,7 +349,7 @@
                 # Note: if there are multiple GROUP assignments in the
                 # topic, only the last will be taken.
                 $group->{members} = 
-                  $this->{session}->{users}->expandUserList( $2 );
+                  $TWiki::USERS->expandUserList( $2 );
             }
         }
         # backlink the user to the group
Index: TWiki/Net.pm
===================================================================
--- TWiki/Net.pm	(revision 13172)
+++ TWiki/Net.pm	(working copy)
@@ -37,11 +37,9 @@
 use vars qw( $LWPavailable );
 
 sub new {
-    my ( $class, $session ) = @_;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my $class = shift;
     my $this = bless( {}, $class );
 
-    $this->{session} = $session;
     $this->{mailHandler} = undef;
 
     return $this;
@@ -147,7 +145,7 @@
             $req .= "Authorization: Basic $base64";
         }
 
-        my $prefs = $this->{session}->{prefs};
+        my $prefs = $TWiki::PREFS;
         my $proxyHost = $prefs->getPreferencesValue('PROXYHOST') ||
           $TWiki::cfg{PROXY}{HOST};
         my $proxyPort = $prefs->getPreferencesValue('PROXYPORT') ||
@@ -225,7 +223,7 @@
 sub _installMailHandler {
     my $this = shift;
     my $handler = 0; # Not undef
-    my $prefs = $this->{session}->{prefs};
+    my $prefs = $TWiki::PREFS;
 
     $this->{MAIL_HOST}  = $prefs->getPreferencesValue( 'SMTPMAILHOST' ) ||
       $TWiki::cfg{SMTP}{MAILHOST};
@@ -242,7 +240,7 @@
             require Net::SMTP;
         };
         if( $@ ) {
-            $this->{session}->writeWarning( "SMTP not available: $@" );
+            $TWiki::SESSION->writeWarning( "SMTP not available: $@" );
         } else {
             $handler = \&_sendEmailByNetSMTP;
         }
@@ -312,7 +310,7 @@
             # caused by SMTP or perl, and give away info about the
             # install that we don't want to share.
             unless( $e =~ /^ERROR/ ) {
-                $this->{session}->writeWarning( $e );
+                $TWiki::SESSION->writeWarning( $e );
                 $e = "Mail could not be sent - see TWiki warning log.";
             }
             $errors .= $e."\n";
